#include <stdio.h>
#include <string.h>
#include <afxwin.h>
#include "resource.h"

class CMyApp : public CWinApp
{
public:
	virtual BOOL InitInstance ();
};

class CCodeDialog : public CDialog
{
private:
	CString m_name;
public:
	CCodeDialog();
protected:
	virtual void OnCancel();
	virtual void PostNcDestroy ();
	afx_msg void OnCalc();

	DECLARE_MESSAGE_MAP()
};

void code(const char* name, char* out);

//******************************************************************************************
CMyApp myApp;

BOOL CMyApp::InitInstance()
{
	m_pMainWnd = new CCodeDialog;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

BEGIN_MESSAGE_MAP(CCodeDialog,CDialog)
	ON_EN_CHANGE(IDC_EDIT1,OnCalc)
END_MESSAGE_MAP()

CCodeDialog::CCodeDialog()
{
	Create(IDD_DIALOG1);
}

void CCodeDialog::OnCancel()
{
	DestroyWindow();
}

void CCodeDialog::PostNcDestroy()
{
	delete this;
}

void CCodeDialog::OnCalc()
{
	char tmp[20]="";

	GetDlgItem(IDC_EDIT1)->GetWindowText(m_name);
	if(m_name.GetLength())
		code(LPCTSTR(m_name),tmp);
	GetDlgItem(IDC_EDIT2)->SetWindowText(tmp);
}

const char codeadd[20] = "h&8!`ffdcGdjka:;#'S";
const int charmap[20] = {12,7,16,18,3,4,6,9,0,13,15,19,2,17,11,8,7,10,14,5};

const int hexmap1[15] = {12,7,3,4,6,9,0,13,2,1,8,11,10,14,5}; //note 5 elements used from hexmap2
const int hexmap2[15] = {6,9,8,2,3,14,4,1,10,5,12,11,0,7,13};


void gcode(const char* code_str, const char* name_str, char* code_data, const int *char_map)
{
	char tmp_str[20];
	char name_code_str[20];
	int name_len,s,t,i,j;
	
	t=strlen(name_str); name_len=(t<20?t:20); //upto 20 chars
	for(i=0;i<20;i++) name_code_str[i]=name_str[i%name_len]+code_str[i]; //code & repeat as necessary
	for(i=0;i<20;i++) tmp_str[i]=name_code_str[i]; //copy
	for(i=0;i<20;i++) name_code_str[i]=tmp_str[char_map[i]]; //map characters
	//sum things strangely
	for(i=0;i<20;i++) {
		for(j=i,s=8;j<20;j++) s+=name_code_str[j];
		name_code_str[20-i]+=s;
	}
	for(i=0;i<10;i++) name_code_str[i]+=name_code_str[i+10]; //combine halves

	for(i=0,t=1,s=0;i<10;i++,t*=10) s+=(name_code_str[i]%10)*t;
	sprintf(code_data,"%010lu",s);

	for(i=0;i<20;i++) tmp_str[i]=code_data[i]; //copy
	for(i=0;i<20;i++) code_data[i]=tmp_str[hexmap1[i]]; //map code
}

void code(const char* name, char* out)
{
	char tmp[20];
	int i,s;
	gcode(codeadd,name,tmp,charmap);
	for(i=0,s=0;i<10;i++) {
		if(i>0 && i%3==0) *out++='-';
		s+=*out++=tmp[hexmap2[i]]; //map code
	}
	s%=99;
	*out++=s/10+'0';
	*out++=s%10+'0';
}
